<?php
// Set the content-type
//http://www.swpc.noaa.gov/sites/default/files/images/u2/Usr_guide.pdf
header('Content-Type: image/png');
date_default_timezone_set('America/Los_Angeles');
include ('MoonPhase.php');
//        0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
//$kp=array(0,0,1,1,1,2,2,2,3,3,4, 4, 4, 4, 4, 5,5,5);
$kp=array(0,0,1,1,1,2,2,2,3,3,3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5,);
//	   0 1 2 3 4  5  6  7   8   9
//$kpb=array(0,1,7,11,19,35,50,100,170,299);
$kpb=array(1,4,7,11,17,35,60,100,170,300);

//echo '<pre>';	// <pre> keep blank space.
//echo '<div style="text-align:center;width:320px;height:130px;font-size:14px"> '; 
//echo date('Y-m-d H:i:s \n');
//printf ("%d \n", time());
//echo '<span style="color:red">这是红色的字</span>';
$file="http://services.swpc.noaa.gov/text/45-day-ap-forecast.txt";
//$file="45-day-ap-forecast.txt";		//test data
$lines = file($file);

$i=0;
$array="";
foreach($lines as $line) {
 $line = rtrim($line);
 $array[$i]=$line;
 $i++;
}

$d=0;
$ap=array();
//	echo date('m/d   ',$t);
$datemark=array(23,44,55);	//use original date stamp
function GetRowData($sin){
	global $kp,$ap,$d,$datemark;
	$datemark[$d]=strtotime( substr($sin,0,7));
	$ap[$d++]=intval(substr($sin,8,3));
	$datemark[$d]=strtotime(substr($sin,12,7));
	$ap[$d++]=intval(substr($sin,21,3));
	$datemark[$d]=strtotime(substr($sin,24,7));
	$ap[$d++]=intval(substr($sin,33,3));
	$datemark[$d]=strtotime(substr($sin,36,7));
	$ap[$d++]=intval(substr($sin,45,3));
	$datemark[$d]=strtotime(substr($sin,48,7));
	$ap[$d++]=intval(substr($sin,57,3));
}

//  http://www.swpc.noaa.gov/products/station-k-and-indices
function Ap2Kp(){
	global $ap,$kp,$kpb;
	$apx=9;
	for ($i=0;$i<45;$i++){		//45 days
		$k=$ap[$i];
		for($j=0;$j<9;$j++){
			if($k<$kpb[$j]) break;		//not <=
		}
		$ap[$i]=$j;
  }
}

function prRow($j){
	global $ap,$d;
	for($i=0;$i<5;$i++){
		$k=$ap[$d];
		if($k>4){
			echo '<span style="color:red">';
		}
		else if ($k>3) {
				echo '<span style="color:#ff8000">';	//oringe
		}
		else{
			echo '<span style="color:#ccc">';
		}
		echo date("m/d=",$j+$i*86400);
	
		printf("%d ",$k);
		echo '</span>';
		$d++;
	}
	echo'<br>';
}

function ShowMoonPhase($time, $x, $y){
	global $moonphase, $im;
	$moondata = phase($time);
	$age=round($moondata[2]);		//moon age
	if($age<0) $age=0;

	$sy=0;
	if ($age>=15) {
	$sy=18;
	$age-=15;
	}
	$sx=$age*18;
	
	imagecopy($im, $moonphase, $x, $y, $sx, $sy, 17, 17 );
	
}
//-------------- run -----------//
//start date
$date1=strtotime(substr($array[10],0,7));
//echo 'Y'.substr($array[1],9,4).'M'.substr($array[1],14,3);
//echo 'D'.substr($array[1],18,2).'h'.substr($array[1],21,4);
//echo date("Y-M-d",$date1);
$s=substr($array[1],9,4).'-'.substr($array[1],14,3).'-'.substr($array[1],18,2).' '.substr($array[1],21,2).':'.substr($array[1],23,2);
//echo $s;
$issuetime=strtotime($s); //to local time
//print_r(date_parse(substr($array[1],9,16)));
//echo date("更新时间：Y.m.d H:i",$issuetime);

//Get 30 days data to ap$[]
$d=0;
for ($i=10;$i<19;$i++){
    GetRowData($array[$i]);
}
// convert ap to kp
Ap2Kp();
//echo date("dmy",$datemark[0]);


//   ------------------------ Part2 Calendar ----------------------------------------->

$YVRlati=49.304;
$YVRlong=-123.144;	//Vancouver Latitude and Longitude

$rtime=$issuetime;	//time()-date('Z');	//PST Day save time --> UTC
//$rtime=$date1;  //date1 is issue date
//echo date('Y-m-d H:i:s ', $rtime);

//$thismonth = getdate ($rtime);	//取得当前时间的结构数组
//printf("%d",$thismonth['wday']);

/* Sun infomaition
$sun_info = date_sun_info($rtime, $YVRlati, $YVRlong);
foreach ($sun_info as $key => $val) {
    echo "$key: " . date("H:i:s", $val) . "\n";
}
*/

$cMonth = date("m",$rtime);	//$_REQUEST["month"];
$cYear = date("Y",$rtime);	//$_REQUEST["year"];
 
 
$prev_year = $cYear;
$next_year = $cYear;
$prev_month = $cMonth-1;
$next_month = $cMonth+1;
 
if ($prev_month == 0 ) {
    $prev_month = 12;
    $prev_year = $cYear - 1;
}
if ($next_month == 13 ) {
    $next_month = 1;
    $next_year = $cYear + 1;
}

//$timestamp = mktime(0,0,0,$cMonth,1,$cYear);
//$maxday = date("t",$timestamp);		//本月天数
$thismonth = getdate ($datemark[0]);	//取得当前时间的结构数组
$startday = $thismonth['wday'];   //day of 1st 第一天星期几
//print_r($thismonth);		//debug
$j=0;		//count
//		0        1        2          3          4       5       6dark red      7         8         9 
$bgc=array("#f0f0f0","#e0e0e0","#c0c0c0","#99ff99","orange","#ff4300","#c00000", "#ff00ff", "#a000d0","black");	//ignored

//array imagettftext ( resource $image , float $size , float $angle , int $x , int $y , int $color , string $fontfile , string $text )
//imagecreatefrompng ( string $filename )
$bgpng='nlc.png';	//278x260
// Create the image
//$im = imagecreatetruecolor(250, 220);'

define ("REFX",18);	//offset 13
define ("REFY",202);	//ofset 13
define ("CW",62);
define ("CH",61);
$im=@imagecreatefrompng($bgpng);
$moonphase=@imagecreatefrompng('Phases30.png');		//moon phase pic

// Create some colors
$white = imagecolorallocate($im, 255, 255, 255);
$grey = imagecolorallocate($im, 128, 128, 128);
$black = imagecolorallocate($im, 0, 0, 0);
//imagefilledrectangle($im, 0, 0, 250, 220, $grey);
//date window lef-top (5,77) unit width 39 High 37,
// The text to draw
$text = '29   Ab /d 12 34';
// Replace path by your own font path
//$font = 'verdana.ttf';
//$font = 'Dustismo_Roman_Bold.ttf';
$font = 'Arial_Black_Regular.ttf';
$x=REFX;
$y=REFY-CH;
$ckp=array(0,1,2,3,4,5,6,7,8,9) ;
$ckp[0]=imagecolorallocate($im, 242, 242, 242);		// light gray
$ckp[1]=imagecolorallocate($im, 217, 217, 217);		//gray
$ckp[2]=imagecolorallocate($im, 191, 191, 191);		//gray
$ckp[3]=imagecolorallocate($im, 0, 176, 80);		// green
$ckp[4]=imagecolorallocate($im, 255, 192, 0);		// orange
$ckp[5]=imagecolorallocate($im, 255, 0, 00);		//red
$ckp[6]=imagecolorallocate($im, 175, 0, 33);		// dark red
$ckp[7]=imagecolorallocate($im, 255, 0, 255);		//magenta
$ckp[8]=imagecolorallocate($im, 148, 0, 212);		//violet
$ckp[9]=imagecolorallocate($im, 96, 0, 96);		//purple

$dd=date("  Y/m/d",$issuetime+date('Z'));     //date of update
imagettftext($im, 16, 00, REFX+CW*3+32, REFY-CH*2-26, $grey, $font, $dd);
for ($i=0; $i<49; $i++) {		//35 days 5 weeks
    if(($i % 7) == 0 ){
     	$x=REFX;			//Sunday, begin
     	$y+=CH;
     	}
    if($i < $startday) $x+=CW;	//skip
    else {
		//echo "<td align='center' valign='middle' height='20px' style='color:#0000FF' bgcolor='";
		$color=$white;
		$kp=$ap[$j];
		if($kp<3) $color=$black;
		//echo $bgc[$ap[$j]];
		imagefilledrectangle($im, $x-2, $y-CH-5, $x+55, $y-13, $ckp[$kp]);
		$dd=date("d",$datemark[$j]);
		imagettftext($im, 18, 00, $x+20, $y-17, $color, $font, $dd);
		ShowMoonPhase($rtime, $x+4, $y-CH+2);
		
		$x+=CW;
		$j++;
		$rtime +=86400;
	
	}
	if($j>=45) break;
	
	//	if(($i % 7) == 6 ) echo "</tr>";
//		$j++;
}


// Add the text
//imagettftext($im, 16, 00, 5, 110, $white, $font, $text);

// Using imagepng() results in clearer text compared with imagejpeg()
//imagepng($im);
//imagedestroy($im);
//imagettftext($im, 16, 00, 50, 140, $white, $font, 'test');
imagepng($im);
imagedestroy($im);

?>