<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1" />


<style>
body
{
	margin:0; padding:0;
}
h1
{
	font-size:18px;
	color:#aaa;
	text-align:center;
}
h2
{
	font-size:22px;
	color:grey;
	text-align:left;
}
p
{
	font-family:"Times New Roman";
	text-align:center
	color:white;
	font-size:20px;
}

.container {
/*	background-color: #333; */
	width: 640px;
	height: 560px;
	border: 0px solid #f00;
}

.div-left{
	float:left;
	background-color: inherit;
	width: 100%; height: 560px;
	border:0px solid #Fff; 
}
.div-right{
	float:right;
	margin-top: 50px ;
	margin-left: auto ;

	width: 400px; height: 560px;
	border:0px solid #Fff; 
}
.div-ltop{
	float:left;
	width: 100%; height: 56px;
	border:0px solid #Fff; 
}
.div-lbot{
	float:left;
	margin-left: 10px ;
	width: 620; height: 486px;
	border:0px solid #Fff; 
}
.div-lt-f1{
	float:left;
	width: 100%; height: 130px;
	border:0px solid #Fff; 
}
.div-lt-f1-l{
	float:left;
	width: 60%; height: 130px;
	border:0px solid #Fff; 
}
.div-lt-f1-r{	/* 1 hour Kp */

	float:left;
	margin-top: 15px ;
	width: 40%; height: 120px;
	border:0px solid #Fff; 
}


.div-lt-f2{
	float:left;
	width: 100%; height: 40px;
	border:0px solid #Fff; 
}
.div-lt-f2-l{	/* form */
	float:left;
	margin-top: 0px ;
	width: 55%; height: 22px;
	border:0px solid #Fff; 
}
.div-lt-f2-r{		/* clock */
	float:left;
	margin-left: 1px ;
	text-align:left;
	width: 42%; 
	background-color: #0f0
	border:0px solid #Fff; 
}

</style>
</head>
<body>


<p id="demo"></p>
<script src="include/geoloc.js" type="text/javascript"></script>

<script type="text/javascript">
    getLocation();

</script>


<?php
	
require_once 'include/myauroravar.php';
include "include/myauroralib.php";
/*  refresh
	$page = $_SERVER['PHP_SELF'];
	$sec = "300";
	header("Refresh: $sec; url=$page");
*/

	session_start(); 

	//	$d=$locinfo['Vancouver'][0];
	if(isset($_POST['location']))
	{
		$selectedloc=$_POST['location'];
	}
	else
		$selectedloc=startLoc();

	$locID=$selectedloc;
	$_SESSION['loc'] = $selectedloc;
?>

<div class="container"> 
	<div class="div-left">
		<div class="div-ltop">
			<div class="div-lt-f2" style="text-align:center">
				<div class="div-lt-f2-l">
					<?php form();  ?>
				</div>
				<div class="div-lt-f2-r"> <h1 id='Clock'> </h1>
					
				</div>
			</div>
		</div>
		<div class="div-lbot">
			<img id="threeDays" src="<?php showKp(); ?>" width=100% >
		</div>
	</div>
</div>  


<script type="text/javascript">
	
function refreshImg(){
	var name=document.getElementById("threeDays").alt;
	var bufferImage = document.getElementById("threeDays").src;
		name +="?t="+new Date().getTime();
	document.getElementById("threeDays").src=name;
}
setInterval("refreshImg();", 600000);		//10 mins
setInterval("Clock.innerHTML=new Date().toLocaleString()+'<br>'+'星期'+'日一二三四五六'.charAt(new Date().getDay());",1000);
</script>
  </body>
  </html>

  
  
<?php 
/*-------------------------------------------------------*/  	
function showKp(){
	
	$selectedloc=$_SESSION['loc'];
//echo "test";
	$d3="kp/d3$selectedloc.png"; 
//	$s01 =' <img id="threeDays" src="';
	$s01 =$d3;
//	$s01 .='" width=100% /> ';
	//printf("%s", $s01);
	echo $s01;
	echo '"  alt="'. $s01;

}
/*-------------------------------------------------------*/  	

/********************************************************
//   Functions
*********************************************************/
/*-------------------------------------------------------*/  	
function showLoc(){
	
	global $locinfo;
	$selectedloc=$_SESSION['loc'];
		
	$timezone=$locinfo[$selectedloc][5];
	date_default_timezone_set($timezone);

	$tm=date("Y-m-d H:i", time());
	echo "当前位置:";	
		echo "$selectedloc <br>";
			echo "网页刷新: $tm ";
}

/*-------------------------------------------------------*/  	
function form(){
	global $locinfo;	
	$locID=$_SESSION['loc'];

	//$file="myaurora.php";
	//echo '<form action='. $file .' target="fr002" method="post" >
	echo '<form action="" method="post" >
	   <select style="font-size: 16pt" name="location"  >  ';

	foreach($locinfo as $loc)
	{
		$v=$loc[0];
		echo "<option value=".$v;
		
		if($v==$locID) echo " selected";
		echo " >". $loc[1]."</option> ";
	}
	  
	echo ' </select>
	   <input  type="submit" style="font-size: 15pt" value="选取观赏点"/>
	   </form> '; 
	 
 	$selectedloc=getSelect();

	  return $loc;
}
  

   
/*-------------------------------------------------------*/

/*********  Check last location ***********/
function startLoc(){
	global $locinfo;
	if(isset($_COOKIE['myloction'])){
		$selectedloc=$_COOKIE['myloction'];
		$useloc='coo';
	}
	else 
	{		//use geo
		if(isset($_COOKIE['browserlat'])&&isset($_COOKIE['browserlon'])){
			$lat=$_COOKIE['browserlat'];
			$lon=$_COOKIE['browserlon'];
			$useloc='geo';
	//find site close to geo		
			$i=0;
			$dist=array();
			foreach($locinfo as $loc){
				$dist[$i++]=distance($lat, $lon, $loc[2], $loc[3], "K" );
			}
			$j=min($dist);
			$cnt=count($locinfo);
			for($i=0;$i<$cnt;$i++){
				if($j==$dist[$i]) break;
			}
			$c=0;
			foreach($locinfo as $key => $loc){
				if($i==$c++) break;
			}
			$selectedloc=$key;
			$site=$locinfo[$selectedloc][1];

			if($j<100){
				$a= 'in ';
			}
			else 
				$a= round($j,0) .'km from: ';
	//		echo "<br> You are  $a $site <br>";
		}
		else		// geo off, no selected, use default
			$selectedloc='Vancouver';		//default
	}
	return $selectedloc;
}	
   
   //processing
function getSelect(){
	if (!isset($_POST['location'])){	//not selected
		$useloc='geo';
		if(isset($_COOKIE['myloction'])){
			$selectedloc=$_COOKIE['myloction'];
			$useloc='coo';
		}
		else $selectedloc='Vancouver';
	}
	else{ 
		$selectedloc=$_POST['location'];
		setcookie('myloction', $selectedloc, time()+60*60*24*365);
//		echo "setcookie: $selectedloc ";
		}
		$_SESSION['loc'] = $selectedloc;

	return $selectedloc;
}

?>