<?php
/*  https://www.wunderground.com/about/data
	it claims "BestForecast" data, update every using 15 minutes, comparing 4 hours of NWS 
	Hourly10day: update in 15min, 
	forecast10day more than 2 hours?
	      (i.e. issue- 9:29 PM File time 10:35pm
		               11:00pm           00:14am)
	   txt_forecast 20 periods with day/night, 
	   simpleforecast: for 7pm every day
	   
	Count clear chance from hourly10day, ( (clear hours)+(Partlyclouds hours/2))/(night hours), 
	Free keys ANVIL PLAN with:
	1.	acwayk / 1@ e03064f9553431f0  dajiguang
	2.  myang67 / 1@ bb71f22b8ef9e074 grandaurora
	Access limit: 500/day  10/minute
*/

/* fctcode
1 - Clear 				'sky' 0~29: 20~30 = most sunny/clear, 0~19 clear/sunny
2 - Partially Cloudy 	'sky' 30~59  35 partly cloudy
3 - Mostly Cloudy 		'sky' 60~79
4 - Overcast 			'sky' 80~100	1~4 'sky'=percent of cloud cover
5 - ? 
6 - Fog 
7 - ? 
8 - ? 
9 - ? 
10 - ? 
11 - ? 
12 - Chance of rain 	'sky'=percent of rain
13 - Rain 				'sky'=100
14 - Chance of storms 
15 - Thunderstorms 
16 - ? 
17 - ? 
18 - ? 
19 - Snow Shower 
20 - Chance of snow 
21 - Snow

		"condition": "Clear",
		"icon": "clear",
		"icon_url":"http://icons.wxug.com/i/c/k/clear.gif",
		"fctcode": "1",
		
		"sky": "20",
		"wspd": {"english": "7", "metric": "11"},
		"wdir": {"dir": "SSE", "degrees": "150"},
		"wx": "Mostly Sunny",						//detailed by sky cover


Country/city
Canada/Vancouver
China/Mohe
*/
include_once (__DIR__ ."/include/myauroravar.php");


define ("WUURL", 'http://api.wunderground.com/api/' );
define ("KEYAC", 'e03064f9553431f0');
define ("KEYMY", 'bb71f22b8ef9e074');
//define("WUURLD10", 'http://api.wunderground.com/api/bb71f22b8ef9e074/forecast10day/q/');
define("WUURLH10", 'http://api.wunderground.com/api/bb71f22b8ef9e074/hourly10day/q/');

//error define
$wtStatus= [
	"NoErr"		=> 0,
	"JSONfailed" => 1,
	"CopyFailed" => 2,		//failed to get json file
	"updateD10"	=> 0,
	"updateH10"	=> 0,
	"uwkey1"	=> "e03064f9553431f0",
	"uwkey2"	=> "e03064f9553431f0",
	"wuurl"		=> "http://api.wunderground.com/api/",
	"d10"		=> "forecast10day",
	"h10"		=> "hourly10day",
	"here"		=> "Vancouver",
	"Vancouver" => ["Canada", "Vancouver"],
	"Edmonton"  => ["Canada", "Edmonton"],
	"filepre"	=> " ",
	
];

/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  */
/*  Test, entry updateWeather()

session_start();
if(isset($_SESSION['loc'])) 
	$loc=$_SESSION['loc'];
else 
	$loc="Vancouver";		//vancouver
$timezone=$locinfo[$loc][5];
date_default_timezone_set($timezone);

$csv=array();

updateWeather($loc);
*/

//$fl="weather/VancouverH10.json";
//$fl="http://api.wunderground.com/api/e03064f9553431f0/forecast10day/q/Canada/Vancouver.json";
//$fl=http://api.wunderground.com/api/e03064f9553431f0/hourly10day/q/Canada/Vancouver.json;		//10 day hourly
// 10 day hourly is inaccurate but confusing for big piture of weather. Use 3 only. others use 10day forecast
// 两个数据都使用。每小时读取一次，按fctcode代码保存

 // var_dump $smpfcst['forecastday'][0];

//test
/*
$fcsv=__DIR__ ."/weather/" .$loc. ".csv";
$dat=csv_to_array($fcsv);
$bt=$dat[0]['epoch'];
var_dump ($dat[239]);
echo "<br>". date("Y-m-d H:i:s",$bt);
*/
/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */

/* --------------------------- Functions ---------------------------------------- */
/* Entry function

*/
$csv=array();
function updateWeather($loc){
	global $wtStatus;
	$s=__DIR__ ."/weather/" .$loc;
	$wtStatus['filepre'] =$s;
	//echo $wtStatus['filepre'];
	$wtStatus['here']=$loc;
	$mtime= checkJson($loc);
	$wtStatus["here"]=$loc;
	
//	echo "<br> Last updated: ". date("Y-m-d H:i:s", $mtime); 
}


/*
1. Check and update weather url forecast10day/hourly10day 
2. Update file Country_City_d10.csv / Country_City_h10.csv
*/

/*
*/

function checkJson($loc){
	global $wtStatus, $locinfo;
	$err=0;		//error code

//Hourly10day	
	$mtime=time();
	$wtStatus['updateH10']=1;
//	var_dump ($wtStatus);
	$fld=$wtStatus['filepre'] ."H10.json";	//i.e. VancouverD10.json
	$wuurl='http://api.wunderground.com/api/';
	$wuurl .=$locinfo[$loc][8];
	$wuurl .='/hourly10day/q/';
	if(file_exists($fld) && (filesize($fld)>10000) ){
		$mtime=filemtime($fld);		//it's UTC, while windows show local time.
		if(time()<($mtime+10*60))	//every 10 minutes
//failed will get a json file but lesss then 10KB
			$wtStatus['updateH10']=0;	//skip
	}
	if($wtStatus['updateH10']){		//reload 
		$fls=$wuurl .$locinfo[$loc][7] .".json";
//		echo "<br> $fls";
		if(!copy($fls, $fld))
			$err |= $wtStatus['CopyFailed']; 

		if(!file_exists($fld))
			$err |= $wtStatus['JSONfailed']; 
		else
			decodeH10($fld);
	}
//	echo "<br>err: $err  H10 @ " .date("H:i:s ", $mtime);	
	return $mtime;		//0 or update time
}
/*

*/

function decodeH10($fld){
	global $wtStatus;
	$csv=array();
	$json_string = file_get_contents($fld);
//echo $json_string;
  
  $parsed_json = json_decode($json_string,true);
	$txtfcst = $parsed_json['hourly_forecast'][0];			//next in 240 hours
	$dt=$txtfcst['FCTTIME'];
//	echo "<br>" .date("Y-m-d  H:i:s ", $dt['epoch'] );
  //	var_dump ($parsed_json);
	for ($i=0; $i<240; $i++)
	{
		
		$txtfcst = $parsed_json['hourly_forecast'][$i];			//next in 240 hours
//	$smpfcst = $parsed_json['forecast']['simpleforecast'];
		
		$dt=$txtfcst['FCTTIME'];
		$date=$dt['pretty'];
		$dt2=$txtfcst['icon' ];
		$dt3=$txtfcst['fctcode' ];
		//第二维按顺序，不按下标！
		$csv[$i]['epoch']=$dt['epoch'];	// UTC
		$csv[$i]['pretty']=$dt['pretty'];
		$csv[$i]['fctcode']=$txtfcst['fctcode' ];
		$csv[$i]['sky']=$txtfcst['sky' ];
		$csv[$i]['icon']=$txtfcst['icon' ];
		
	}
	ArrayToCSV(($wtStatus["filepre"] .".csv"), $csv );

	return ;
	//var_dump ($csv);
}


/* Save array to CSV file
*/
function ArrayToCSV($fp, $arry){
	$fh=fopen($fp, 'w+');	//folder must be pre-created
	
	$keys=array_keys($arry[0]);
	fputcsv($fh, $keys);		//keys as header
//	var_dump($keys);
// Generate CSV data from array
     //write out the data
        foreach ( $arry as $row ) {
                fputcsv($fh, $row);
        }
		fclose($fh);
}

/**
 * Function returns XML string for input associative array. 
 * @param Array $array Input associative array
 * @param String $wrap Wrapping tag
 * @param Boolean $upper To set tags in uppercase
 */
 /*
function array2xml($array, $wrap='ROW0', $upper=true) {
    // set initial value for XML string
    $xml = '';
    // wrap XML with $wrap TAG
    if ($wrap != null) {
        $xml .= "<$wrap>\n";
    }
    // main loop
    foreach ($array as $key=>$value) {
        // set tags in uppercase if needed
        if ($upper == true) {
            $key = strtoupper($key);
        }
        // append to XML string
        $xml .= "<$key>" . htmlspecialchars(trim($value)) . "</$key>";
    }
    // close wrap TAG if needed
    if ($wrap != null) {
        $xml .= "\n</$wrap>\n";
    }
    // return prepared XML string
    return $xml;
}
*/

//var_dump($dat);
/**
* @link http://gist.github.com/385876
*/
function csv_to_array($filename, $delimiter=',')
{
//	echo "<br>CSV:"; 
    if(!file_exists($filename) || !is_readable($filename))
        return FALSE;
//	echo $filename;
    $header = NULL;
    $data = array();
    if (($handle = fopen($filename, 'r')) !== FALSE)
    {
        while (($row = fgetcsv($handle, 1000, $delimiter)) !== FALSE)
		{
			//  With header this scenery. Should put keys to header
            if(!$header)
                $header = $row;
            else
                $data[] = array_combine($header, $row);
        
		//	$data[]=$row;
		}
		
        fclose($handle);
    }
    return $data;
}
/*===========================================================*/

?>
